const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const commissions = sequelize.define(
    'commissions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"payable",


"paid",


"reversed"

        ],

      },

gross_profit_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

commission_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

commission_rate_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

earned_at: {
        type: DataTypes.DATE,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  commissions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.commissions.belongsTo(db.affiliate_memberships, {
      as: 'membership',
      foreignKey: {
        name: 'membershipId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.wallet_transactions, {
      as: 'wallet_transaction',
      foreignKey: {
        name: 'wallet_transactionId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.commissions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.commissions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return commissions;
};


